<template>
  <div class="container">
    <div class="table-top" :class="$mq">
      <div class="search-input">
        <form @submit.prevent="resetSearch">
          <div class="input-group">
            <input type="text" v-model.lazy="search" placeholder="Search by URL" />
            <button type="submit" class="input-addon btn btn-blue">
              <i class="fa fa-fw fa-search"></i> Search
            </button>
          </div>
        </form>
      </div>
      <div class="pagination">
        <pagination
           v-if="pagination.total_pages > 1"
           :current-page="currentPage"
           :total-pages="parseInt(pagination.total_pages)"
           @goToPage="changePage">
        </pagination>
      </div>
    </div>
    <div class="table-responsive">
      <table>
        <thead>
          <th>Original URL</th>
          <th>Short Link</th>
          <th>N</th>
          <th>Created at</th>
          <th>Expire at</th>
          <th>Validity</th>
          <th>Actions</th>
        </thead>
        <tbody>
          <ShortLink
            v-for="link in shortLinks"
            :link="link"
            :key="link.id"
            @removeLink="removeLink"
            @updateLink="updateLink" />
        </tbody>
      </table>
    </div>
    <div class="pagination">
      <pagination
         v-if="pagination.total_pages > 1"
         :current-page="currentPage"
         :total-pages="parseInt(pagination.total_pages)"
         @goToPage="changePage">
      </pagination>
    </div>
  </div>
</template>

<script>
import Vue from 'vue'
import pagination from '@/components/Pagination.vue'
import ShortLink from '@/components/ShortLink.vue'

export default{
  components: { pagination, ShortLink },
  data () {
    return {
      shortLinks: [],
      loading: true,
      search: this.$route.query.search || '',
      currentPage: parseInt(this.$route.query.page) || 1,
      pagination: {}
    }
  },
  watch: {
    search () {
      this.resetSearch()
    },
    currentPage: {
      handler: 'getShortLinks',
      immediate: true,
    }
  },
  methods: {
    updateLink (link) {
      Vue.set(this.shortLinks, this.shortLinks.findIndex(l => l.id == link.id), link)
    },
    removeLink (id) {
      this.shortLinks = this.shortLinks.filter(l => l.id != id)
    },
    getShortLinks () {
      this.loading = true
      this.$http.get(`/short_links?page=${this.currentPage}&search=${this.search}`)
      .then( (response) => {
        this.shortLinks = response.data.short_links
        this.pagination = response.data.meta.pagination

        let query = {
          search: this.search,
          page: this.currentPage
        }
        this.$router.replace({ query })
        this.loading = false
        document.body.scrollTop = document.documentElement.scrollTop = 0
      })
    },
    resetSearch () {
      if (this.currentPage == 1) {
        this.getShortLinks()
      } else {
        this.currentPage = 1
      }
    },
    changePage(page) {
      this.currentPage = page
    },
  },
}
</script>

<style lang='sass' scoped>
.container
  display: flex
  justify-content: center
  flex-direction: column
  align-items: center
  .table-top
    width: 100%
    display: flex
    justify-content: space-between
    &.sm,&.xs
      flex-direction: column
      align-items: center
    .input-group
      display: flex
      margin-bottom: 5px
      input
        flex: 1
        line-height: 16px
        padding: 0px 30px 0px 15px
        font-size: 14px
        border: 1px solid #aaa
        border-top-left-radius: 5px
        border-bottom-left-radius: 5px
      .input-addon
        border-radius: 0
        border-top-right-radius: 5px
        border-bottom-right-radius: 5px
  .table-responsive
    width: 100%
    overflow-x: auto
    table
      width: 100%
      margin-bottom: 20px
      border: 1px solid black
      border-collapse: collapse
      th
        border: 1px solid #ddd;
        padding: 8px;
        text-align: center
        background-color: slategray
        color: white
        padding-top: 12px;
        padding-bottom: 12px;
</style>
